/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sys_config.c,v 1.1 2008/06/17 00:04:50 suikan Exp $
 */

/*
 *	^[QbgVXeˑW[iM3029pj
 */

#include "jsp_kernel.h"
#include <sil.h>
#include "m3029.h"

/*
 *  ^[QbgVXeˑ [`
 */

void
sys_initialize(void)
{
	VB * p;

	/* 
	 * [q蓖Đ䃌WX^̏
	 * s܂ňꕔ̒[q͓삵Ȃ 
	 */
	/* bN */
	sil_wrb_mem((VP)(TADR_SFR_PRCR), TVAL_PACR_PRCR);
#ifdef PIN80 
	sil_wrb_mem((VP)(TADR_SFR_PACR), TVAL_80_PACR);
#else /* PIN64 */
	sil_wrb_mem((VP)(TADR_SFR_PACR), TVAL_64_PACR);
#endif
	/* bN */
	sil_wrb_mem((VP)(TADR_SFR_PRCR), 0x00);
		
	/* Rg[#2WX^̏ */
	p = (VB*)TADR_SFR_UART0_BASE;
	sil_wrb_mem((VP)(p+TADR_SFR_UC2_OFFSET), 0x00);
	
#if CONSOLE_PORTID == 1
	p = (VB*)TADR_SFR_UART0_BASE;
#else	/* CONSOLE_PORTID == 2 */
	p = (VB*)TADR_SFR_UART1_BASE;
#endif	
	
	/* M[hWX^̏ */
	sil_wrb_mem((VP)(p+TADR_SFR_UMR_OFFSET), 0x05);	/* M|hWX^ NbN,*/
													/* 񓯊A8rbgApeBȂA	*/
													/* X[vȂ						*/
	/* M䃌WX^̏ */
	sil_wrb_mem((VP)(p+TADR_SFR_UC0_OFFSET), 0x10);	/* M䃌WX^0 NbNf1I */
	/* ]xWX^̏ (38400bps32) */
	sil_wrb_mem((VP)(p+TADR_SFR_UBRG_OFFSET), 32);	/* ]xWX^(19200bps)		*/
	/* M䃌WX^̏ */
	sil_wrb_mem((VP)(p+TADR_SFR_UC1_OFFSET), (TBIT_UiC1_TE | TBIT_UiC1_RE));
													/* M䃌WX^P M	*/

	/* |[g0̏ */
	sil_wrb_mem((VP)TADR_SFR_P0, 0xff);				/* |[g0f[^				*/
	sil_wrb_mem((VP)TADR_SFR_PD0, 0xff);			/* |[g0o͐ݒ					*/
}

/*
 *  ^[QbgVXȅI[`
 */

void
sys_exit(void)
{
  while (1)
  	;
}

void
sys_putc(char c)
{
	if(c == '\n'){
	    m3029_putc( '\r' );
	}
    m3029_putc( c );
}


