/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2004 by SEIKO EPSON Corp, JAPAN
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */
#include	"smcvals.h"
#include	"stdio.h"
#include	"cpu_rename.h"

FILE	_iob[FOPEN_MAX + 1];		/* standard i/o stream */

FILE	*stdin; 			/* standard input */
FILE	*stdout;			/* standard output */
FILE	*stderr;			/* standard error */

int 	errno;				/* error number */

unsigned int  seed; 			/* seed of random value */

unsigned char *ucNxtAlcP;	/* next memory allocate address */
unsigned char *ucBefAlcP;	/* one previous allocated address */
unsigned char *end_alloc;	/* end memory allocate address */

#ifndef DBL_LNG_TYPE

#define DBL_LNG_TYPE

/*  the architecture of double floating point
 *
 *   0 1          11                  31 32                               63 bit
 *   -----------------------------------------------------------------------
 *  | |   exponent  |                    fraction                           |
 *   -----------------------------------------------------------------------
 *
 *  |               |                   |                                   |
 *  |     12bits          20 bits       |             32 bits               |
 *  |            lower word             |            higher word            |
 *
 *         bit    0         sign bit         (  1 bit  )
 *              1 - 11      exponent part    ( 11 bits )
 *             12 - 63      fraction part    ( 52 bits )
 *
 */

typedef union {
		struct {
#ifdef	BIG_ENDIAN
			unsigned long _LL;
			unsigned long _LH;
#else
			unsigned long _LH;
			unsigned long _LL;
#endif
		} st;
	} DBL_LNG;

#endif

DBL_LNG _HUGE;				/* HUGE VALUE */

unsigned char *_STACK_TOP;		/* address of stack top */
unsigned char *_STACK_BOTTOM;		/* address of stack bottom */

long gm_sec;

/*
 * initialize routine
 */

void init_lib()
{

  /* initialize allocate address */
  end_alloc = (unsigned char *)_STACK_TOP;
  ucNxtAlcP = (unsigned char *)(_BOUND((unsigned long)_STACK_BOTTOM));
  ucBefAlcP = (unsigned char *)NULL;

  errno = 0;				/* clear error number */

  seed = 1; 				/* initialize random seed */

  gm_sec = -1;				/* initialize time */

  _HUGE.st._LL = 0x7ff00000;		/* HUGE VALUE */
  _HUGE.st._LH = 0;

/*
 *  INITIALIZE STANDARD STREAMS
 */

  _iob[0]._flg = _UGETN;		/* initialize stdin stream */
  _iob[0]._buf = 0;
  _iob[0]._fd = 0;

  _iob[1]._flg = _UGETN;		/* initialize stdout stream */
  _iob[1]._buf = 0;
  _iob[1]._fd = 1;

  _iob[2]._flg = _UGETN;		/* initialize stderr stream */
  _iob[2]._buf = 0;
  _iob[2]._fd = 2;

  stdin = &_iob[0];
  stdout = &_iob[1];
  stderr = &_iob[2];

}

