/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: device.h,v 1.1 2008/06/17 00:04:36 suikan Exp $
 */

#ifndef __DEVICE_H
#define __DEVICE_H

#include <cpu_rename.h>
#include <s_services.h>

#ifdef DEVICE_ENABLE

#define MAX_MSGSIZE 256

#define DEVICE_TIMEOUT INFINITE

#define OnDevice

extern struct tagDeviceGlobalVariables
{
    CRITICAL_SECTION cs;
    HANDLE ManagerSlot;
    HANDLE ListenerThread;
    HANDLE Blocker;
    HANDLE ThreadBlocker;
    HANDLE ReplySlot;
    DWORD ListenerThreadID;
} DeviceVars;

void InitializeDeviceSupportModule(void);
void FinalizeDeviceSupportModule(void);

int DeviceRead(unsigned long address, unsigned long size, void * storage);
int DeviceWrite(unsigned long address, unsigned long size, void * storage);


#define SIL_ENDIAN SIL_ENDIAN_LITTLE

/*
 *  GfBA̔]
 */
#ifndef SIL_REV_ENDIAN_H
#define	SIL_REV_ENDIAN_H(data) \
    ((VH)((((UH)(data) & 0xff) << 8) | (((UH)(data) >> 8) & 0xff)))
#endif /* SIL_REV_ENDIAN_H */

#ifndef SIL_REV_ENDIAN_W
#define	SIL_REV_ENDIAN_W(data) \
    ((VW)((((UW)(data) & 0xff) << 24) | (((UW)(data) & 0xff00) << 8) \
    | (((UW)(data)>> 8) & 0xff00) | (((UW)(data) >> 24) & 0xff)))
#endif /* SIL_REV_ENDIAN_H */

/*
 *  RȃGfBAł̓Ǐo
 */
Inline VB
sil_reb_mem(VP mem)
{
    VB data;
    DeviceRead((unsigned long)mem, sizeof(data), &data);
    return data;
}

Inline VH
sil_reh_mem(VP mem)
{
    VH data;
    DeviceRead((unsigned long)mem, sizeof(data), &data);
    return data;
}

Inline VW
sil_rew_mem(VP mem)
{
    VW data;
    DeviceRead((unsigned long)mem, sizeof(data), &data);
    return data;
}

Inline void
sil_rek_mem(VP mem, VP data, UINT len)
{	DeviceRead((unsigned long)mem, len, data);   }

/*
 *  gGfBAł̓ǏoigGfBAvZbTj
 */
#define	sil_reh_lem(mem)	sil_reh_mem(mem)
#define	sil_rew_lem(mem)	sil_rew_mem(mem)

/*
 *  rbOGfBAł̓ǏoigGfBAvZbTj
 */
Inline VH
sil_reh_bem(VP mem)
{   return SIL_REV_ENDIAN_H(sil_reh_mem(mem));   }

Inline VW
sil_rew_bem(VP mem)
{   return SIL_REV_ENDIAN_W(sil_rew_mem(mem));   }

/*
 *  RȃGfBAł̏
 */
Inline void
sil_wrb_mem(VP mem, VB data)
{   DeviceWrite((unsigned long)mem, sizeof(data), &data);   }

Inline void
sil_wrh_mem(VP mem, VH data)
{   DeviceWrite((unsigned long)mem, sizeof(data), &data);   }

Inline void
sil_wrw_mem(VP mem, VW data)
{   DeviceWrite((unsigned long)mem, sizeof(data), &data);   }

Inline void
sil_wrk_mem(VP mem, VP data, UINT len)
{	DeviceWrite((unsigned long)mem, len, data);   }

#define	sil_wrh_lem(mem, data)	sil_wrh_mem(mem, data)
#define	sil_wrw_lem(mem, data)	sil_wrw_mem(mem, data)

/*
 *  rbOGfBAł̏݁igGfBAvZbTj
 */
Inline void
sil_wrh_bem(VP mem, VH data)
{
    data = SIL_REV_ENDIAN_H(data);
    DeviceWrite((unsigned long)mem, sizeof(data), &data);   		
}

Inline void
sil_wrw_bem(VP mem, VW data)
{
    data = SIL_REV_ENDIAN_W(data);
    DeviceWrite((unsigned long)mem, sizeof(data), &data);   		
}

#else // DEVICE_ENABLE

//foCX͗pȂ

#define OnDevice /##/
#define InitializeDeviceSupportModule /##/
#define FinalizeDeviceSupportModule /##/

/*
#define DeviceRead(address, size, storage) \
    memcpy(storage, (void *)address, size)

#define DeviceWrite(address, size, storage) \
    memcpy((void *)address, storage, size)
*/

#define DeviceRead /##/
#define DeviceWrite /##/

#endif

#endif

